<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
    <link href="https://fonts.googleapis.com/css?family=Roboto&display=swap" rel="stylesheet">
    <style>
        * {
            font-family: 'Roboto Thin', sans-serif;
        }
        body {
            background-color: black;
            color: white;
        }
        table {
            width: 100%;
        }
        th {
            background-color: maroon;
        }
        tr:nth-child(even) td {
            background-color: #333333;
        }
        th, td {
            padding: 8px;
            text-align: center;
        }
        table, table td, table th {
            border: 1px solid;
            border-collapse: collapse;
        }
        #logout {
            background: #ff4444;
            border: none;
            border-radius: 4px;
            position: absolute;
            top: 5px;
            right: 5px;
            width: 100px;
            padding: 8px 16px;
            color: white;
            cursor: pointer;
        }
        #userNavigation {
            background: #4444FF;
            border: none;
            border-radius: 4px;
            position: absolute;
            top: 5px;
            right: 120px;
            width: 150px;
            padding: 8px 16px;
            color: white;
            cursor: pointer;
            text-decoration: none;
        }
        /* The Modal (background) */
        .modal {
            display: none; /* Hidden by default */
            position: fixed; /* Stay in place */
            z-index: 1; /* Sit on top */
            padding-top: 100px; /* Location of the box */
            left: 0;
            top: 0;
            width: 100%; /* Full width */
            height: 100%; /* Full height */
            overflow: auto; /* Enable scroll if needed */
            background-color: rgb(0,0,0); /* Fallback color */
            background-color: rgba(0,0,0,0.4); /* Black w/ opacity */
        }

        /* Modal Content */
        .modal-content {
            background-color: #fefefe;
            margin: auto;
            padding: 20px;
            border: 1px solid #888;
            width: 80%;
        }

        /* The Close Button */
        .close {
            color: #aaaaaa;
            float: right;
            font-size: 28px;
            font-weight: bold;
        }

        .close:hover,
        .close:focus {
            color: #000;
            text-decoration: none;
            cursor: pointer;
        }
    </style>
</head>
<body>
    <h1>Entry-Verwaltung</h1>
    <div id="entries"></div>
    <br><br><br>
    <form action="#">
        CheckIn:<br>
        <input id="checkIn" type="text" name="checkIn">
        <br>
        CheckOut:<br>
        <input id="checkOut" type="text" name="checkOut">
        <br>
        Project-Id:<br>
        <input id="projectId" type="text" name="projectId">
        <br><br>
        <input type="button" onclick="submitEntry()" value="Submit">
    </form>
    <button id="logout">Logout</button>
    <a id="userNavigation" href="/interface/user.html">User-Verwaltung</a>

    <!-- The Modal -->
    <div id="myModal" class="modal">

        <!-- Modal content -->
        <div class="modal-content">
            <span class="close">&times;</span>
            <form action="#">
                CheckIn:<br>
                <input id="updateCheckIn" type="text" name="checkIn">
                <br>
                CheckOut:<br>
                <input id="updateCheckOut" type="text" name="checkOut">
                <br>
                Project-ID:<br>
                <input id="updateProjectID" type="text" name="projectID">
                <br><br>
                <input type="button" id="updateEntryButton" onclick="updateEntry()" value="Submit">
            </form>
        </div>

    </div>
    <script>
        var payload = JSON.parse(atob(localStorage.getItem("token").split(".")[1]));

        function getEntries() {
            var xhttp = new XMLHttpRequest();
            xhttp.onreadystatechange = function() {
                if (this.readyState == 4 && this.status == 200) {
                    var entries = JSON.parse(this.responseText);
                    var rootNode = document.getElementById("entries");
                    if (entries.length === 0) {
                        var noEntriesFoundNode = document.createElement("H5");
                        var textNode = document.createTextNode("No Entries found");
                        noEntriesFoundNode.appendChild(textNode);
                        rootNode.appendChild(noEntriesFoundNode);
                    } else {
                        var tableNode = document.createElement("table");
                        tableNode.setAttribute("id", "tableNode");
                        var headerNode = document.createElement("tr");

                        var idHeaderNode = document.createElement("th");
                        var idHeaderTextNode = document.createTextNode("ID");
                        idHeaderNode.appendChild(idHeaderTextNode);
                        headerNode.appendChild(idHeaderNode);

                        var checkInHeaderNode = document.createElement("th");
                        var checkInHeaderTextNode = document.createTextNode("Check In");
                        checkInHeaderNode.appendChild(checkInHeaderTextNode);
                        headerNode.appendChild(checkInHeaderNode);

                        var checkOutHeaderNode = document.createElement("th");
                        var checkOutHeaderTextNode = document.createTextNode("Check Out");
                        checkOutHeaderNode.appendChild(checkOutHeaderTextNode);
                        headerNode.appendChild(checkOutHeaderNode);

                        var projectIdHeaderNode = document.createElement("th");
                        var projectIdHeaderTextNode = document.createTextNode("Project ID");
                        projectIdHeaderNode.appendChild(projectIdHeaderTextNode);
                        headerNode.appendChild(projectIdHeaderNode);

                        var deleteHeaderNode = document.createElement("th");
                        var deleteHeaderTextNode = document.createTextNode("Delete Entry");
                        deleteHeaderNode.appendChild(deleteHeaderTextNode);
                        headerNode.appendChild(deleteHeaderNode);

                        var updateHeaderNode = document.createElement("th");
                        var updateHeaderTextNode = document.createTextNode("Update Entry");
                        updateHeaderNode.appendChild(updateHeaderTextNode);
                        headerNode.appendChild(updateHeaderNode);

                        tableNode.appendChild(headerNode);

                        entries.forEach(function(entry) {
                            createRow(entry, tableNode);
                        });
                        rootNode.appendChild(tableNode);
                    }
                }
            };
            xhttp.open("GET", "/api/entries", true);
            xhttp.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("token"));
            xhttp.send();
        }

        function submitEntry() {
            var valCheckIn = document.getElementById("checkIn").value;
            var valCheckOut = document.getElementById("checkOut").value;
            var valProjectId = document.getElementById("projectId").value;

            var xhttp = new XMLHttpRequest();
            xhttp.onreadystatechange = function() {
                if (this.readyState == 4 && this.status == 201) {
                    location.reload();
                }
            };
            xhttp.open("POST", "/api/entries", true);
            xhttp.setRequestHeader("Content-Type", "application/json");
            xhttp.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("token"));
            xhttp.send(JSON.stringify({
                checkIn: valCheckIn,
                checkOut: valCheckOut,
                project: {
                    id: parseInt(valProjectId)
                },
                user: {
                    username: payload.sub
                }
            }));
        }

        function deleteEntry(id) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function() {
                if (this.readyState == 4 && this.status == 200) {
                    location.reload();
                }
            }
            xhr.open("DELETE", "/api/entries/" + id, true);
            xhr.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("token"));
            xhr.send();
        }

        function createRow(entry, tableNode) {
            var rowNode = document.createElement("tr");
            rowNode.setAttribute("data-id", entry.id)

            var idTdNode = document.createElement("td");
            var idTextNode = document.createTextNode(entry.id);
            idTdNode.appendChild(idTextNode);
            rowNode.appendChild(idTdNode);

            var checkInTdNode = document.createElement("td");
            var checkInTextNode = document.createTextNode(entry.checkIn);
            checkInTdNode.appendChild(checkInTextNode);
            rowNode.appendChild(checkInTdNode);

            var checkOutTdNode = document.createElement("td");
            var checkOutTextNode = document.createTextNode(entry.checkOut);
            checkOutTdNode.appendChild(checkOutTextNode);
            rowNode.appendChild(checkOutTdNode);

            var projectIDTdNode = document.createElement("td");
            var projectIDTextNode = document.createTextNode(entry.project.id);
            projectIDTdNode.appendChild(projectIDTextNode);
            rowNode.appendChild(projectIDTdNode);

            var deleteTdNode = document.createElement("td");
            var deleteButtonNode = document.createElement("button");
            deleteButtonNode.setAttribute("onclick", "deleteEntry(" + entry.id + ")");
            var deleteTextNode = document.createTextNode("Delete Me");
            deleteButtonNode.appendChild(deleteTextNode);
            deleteTdNode.appendChild(deleteButtonNode);
            rowNode.appendChild(deleteTdNode);

            var updateTdNode = document.createElement("td");
            var updateButtonNode = document.createElement("button");
            updateButtonNode.setAttribute("onclick", "openUpdateModal(" + entry.id + ")");
            var updateTextNode = document.createTextNode("Update Me");
            updateButtonNode.appendChild(updateTextNode);
            updateTdNode.appendChild(updateButtonNode);
            rowNode.appendChild(updateTdNode);

            tableNode.appendChild(rowNode);
        }

        document.getElementById("logout").addEventListener("click", function() {
            localStorage.removeItem("token");
            window.location.replace("/login/index.html");
        })

        window.onload = function() {
            if (localStorage.getItem("token") !== null) {
                getEntries();
            } else {
                window.location.replace("/login/index.html")
            }
        };

        // Get the modal
        var modal = document.getElementById("myModal");

        // Get the <span> element that closes the modal
        var span = document.getElementsByClassName("close")[0];

        // When the user clicks on <span> (x), close the modal
        span.onclick = function() {
            modal.style.display = "none";
        }

        // When the user clicks anywhere outside of the modal, close it
        window.onclick = function(event) {
            if (event.target == modal) {
                modal.style.display = "none";
            }
        }

        function openUpdateModal(id) {
            modal.style.display = "block";
            var row = document.querySelector("[data-id='" + id + "']");
            var originalCheckInValue = row.children[1].textContent;
            var originalCheckOutValue = row.children[2].textContent;
            var originalProjectIDValue = row.children[3].textContent;

            document.getElementById("updateEntryButton").setAttribute("data-id", id);

            document.getElementById("updateCheckIn").value = originalCheckInValue;
            document.getElementById("updateCheckOut").value = originalCheckOutValue;
            document.getElementById("updateProjectID").value = originalProjectIDValue;
        }

        function updateEntry() {
            var valCheckIn = document.getElementById("updateCheckIn").value;
            var valCheckOut = document.getElementById("updateCheckOut").value;
            var valProjectID = document.getElementById("updateProjectID").value;

            var xhttp = new XMLHttpRequest();
            xhttp.onreadystatechange = function() {
                if (this.readyState == 4 && this.status == 200) {
                    location.reload();
                }
            };
            xhttp.open("PUT", "/api/entries/" + document.getElementById("updateEntryButton").getAttribute("data-id"), true);
            xhttp.setRequestHeader("Content-Type", "application/json");
            xhttp.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("token"));
            xhttp.send(JSON.stringify({
                checkIn: valCheckIn,
                checkOut: valCheckOut,
                project: {
                    id: parseInt(valProjectID)
                }
            }));
        }
    </script>
</body>
</html>